# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from osv import fields, osv
from tools import config
    
class sale_order_line(osv.osv):
    _inherit = "sale.order.line"

    _columns = {
        'sale_price_unit_tax': fields.float('Sale price W/O taxes'),
    }
    
    def product_id_change(self, cr, uid, ids, pricelist, product, qty=0,
            uom=False, qty_uos=0, uos=False, name='', partner_id=False,
            lang=False, update_tax=True, date_order=False, packaging=False, fiscal_position=False, flag=False):
        
        tax_obj = self.pool.get('account.tax')
        
        result = super(sale_order_line, self).product_id_change(cr, uid, ids, pricelist, product, qty,
            uom, qty_uos, uos, name, partner_id, lang, update_tax, date_order, packaging, fiscal_position, flag)
        if product:
            context = {'lang': lang, 'partner_id': partner_id, 'qty': qty}
            product_obj = self.pool.get('product.product').browse(cr, uid, product, context=context)
            result['value']['sale_price_unit_tax'] = product_obj.product_tmpl_id.price_unit_tax

        return result
    
sale_order_line()

class sale_order(osv.osv):
    _name = "sale.order"
    _inherit = "sale.order"
    
    def onchange_shop_id(self, cr, uid, ids, shop_id):
        res = super(sale_order, self).onchange_shop_id(cr, uid, id, shop_id)
        if 'value' in res and shop_id:
            res['value']['price_type'] = self.pool.get('sale.shop').browse(cr, uid , shop_id).price_type
        return res
    
sale_order()


class sale_shop(osv.osv):
    _name = 'sale.shop'
    _inherit = 'sale.shop'
    _columns = {
          'price_type': fields.selection([
            ('tax_included','Tax included'),
            ('tax_excluded','Tax excluded')
        ], 'Price method', required=True),
    }
    _defaults = {
        'price_type': lambda *a: 'tax_included',
    }

sale_shop()

class sale_shop_price_method_policy(osv.osv_memory):
    _name = 'sale.shop.price.method'
    _columns = {
        'name': fields.char('Name', size=64),
        'price_type': fields.selection([
            ('tax_included','Tax included'),
            ('tax_excluded','Tax excluded')
        ], 'Price method', required=True),
    }
    _defaults = {
        'price_type': lambda *a: 'tax_included',
    }
    
    def set_default(self, cr, uid, ids, context=None):
        for o in self.browse(cr, uid, ids, context=context):
            ir_values_obj = self.pool.get('ir.values')
            ir_values_obj.set(cr, uid, 'default', False, 'price_type', ['sale.shop'], o.price_type)
        return {
                'view_type': 'form',
                "view_mode": 'form',
                'res_model': 'ir.actions.configuration.wizard',
                'type': 'ir.actions.act_window',
                'target': 'new',
         } 
        
    def action_cancel(self,cr,uid,ids,conect=None):
        return {
                'view_type': 'form',
                "view_mode": 'form',
                'res_model': 'ir.actions.configuration.wizard',
                'type': 'ir.actions.act_window',
                'target':'new',
        }
        
sale_shop_price_method_policy()