# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields

class sale_prize_information(osv.osv_memory):
    _name = 'sale.prize.information'
    _description = 'Sale Prize Information'
    _columns = {
        'pricelist_id': fields.many2one('product.pricelist', 'Pricelist',required= True),
        'partner_id': fields.many2one('res.partner', 'Customer',required= True),
        'product_id': fields.many2one('product.product', 'Product',required= True),
        'quantity1': fields.float('Quantity1'),
        'quantity2': fields.float('Quantity2'),
        'customer_prices1':fields.float('Costomer Prices'),
        'customer_prices2':fields.float('Costomer Prices'),
        'last_customer_prices':fields.float('Last Costomer Prices'),
        'list_prices1':fields.float('List Prices'),
        'list_prices2':fields.float('List Prices'),
        'last_list_prices':fields.float('Last List Prices'),
        'next_better_price_qty':fields.float('Next Better Price Qty'),
        'best_price_on_qty':fields.float('Best Price On Quantity'),
        'qty_buyed':fields.float('Quantity Buyed'),
                }
    _defaults = {
        'quantity1': lambda *a: 1.0,
        'quantity2': lambda *a: 5.0,

         }

    def set_default(self, cr, uid, ids, context=None):
            obj = self.pool.get('product.pricelist')
            obj2 = self.pool.get('product.pricelist.item')
            obj3 = self.pool.get('sale.order.line')
            form = self.read(cr, uid, ids, [])[0]
            partner = form['partner_id']
            pricelist = form['pricelist_id']
            product = form['product_id']
            qty1 = form['quantity1']
            qty2 = form['quantity2']
            val1 = obj.price_get(cr, uid, ids, product, qty1, partner)
            for key,values  in val1.items():
                c_price1 = values
            val2 = obj.price_get(cr, uid, ids, product, qty2, partner)
            for key,values  in val2.items():
                c_price2 = values
            item_line = obj2.search(cr,uid,[])
            list = []
            for line in obj2.browse(cr, uid,item_line, context=context):
                if product == line.product_id.id:
                        list.append(line.min_quantity)
            if list == []:
                m_qty = 1.0
            else:
                m_qty = max(list)
            val3 = obj.price_get(cr, uid, ids, product, m_qty, partner)
            for key,values  in val3.items():
                c_price3 = values
            list_price = self.pool.get("product.product").browse(cr, uid, product).standard_price
            list_price1 = list_price * qty1
            list_price2 = list_price * qty2
            read_id = obj3.search(cr,uid,[('product_id','=',product)])
            if read_id == []:
                last_price = 0.0
                qty_last = 0.0
                last_list_price = 0.0
            else:
                last_id = max(read_id)
                last_brw = obj3.browse(cr,uid,[last_id],context=context)
                for rec in last_brw:
                     product2 = rec.product_id.id
                     if product == product2:
                         last_price = rec.price_unit
                         qty_last = rec.product_uom_qty
                         val_last = obj.price_get(cr, uid,ids, product2, qty_last)
                         for key,values  in val_last.items():
                             last_list_price = values
            self.write(cr , uid, ids,{'customer_prices1':c_price1,'customer_prices2':c_price2,'list_prices1':list_price1,'list_prices2':list_price2,'next_better_price_qty':m_qty,'best_price_on_qty':c_price3,'last_customer_prices':last_price,'qty_buyed':qty_last,'last_list_prices':last_list_price},context=context)
            value = {

                    'name': 'Sale Prize Information',
                    'view_type': 'form',
                    'view_mode': 'tree,form',
                    'res_model': 'sale.prize.information',
                    'type': 'ir.actions.act_window',
                    }

sale_prize_information()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: