# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv
from tools import config

class product_product(osv.osv):
    _inherit = "product.product"

    def _product_available_other_shop(self, cr, uid, ids, name, arg, context={}):

        res = {}
        product_obj = self.pool.get('product.product')
        shop = context.get('shop', False)
        fields_name = ['qty_available']
        stock2 = product_obj._product_available(cr, uid, ids ,fields_name,context={})
        context.update({'shop':shop})
        stock1 = product_obj._product_available(cr, uid, ids ,fields_name,context=context)
        for key,value in stock2.items():
            res[key] = stock2[key]['qty_available'] - stock1[key]['qty_available']
        return res

    _columns = {
        'qty_available_other_shop': fields.function(_product_available_other_shop, method=True, type='float', string='Other Shops', help="Current quantities of products in other stock location except selected shop in sale order."),
    }

product_product()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
